<?php

namespace DataView;

class Fop_mail_host_box_dir_email_attachment {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderScript() { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_fop_mail_host_box_dir_email_attachment_emailListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_dir_email_attachment_email', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_dir_email_attachment_email'];
		  }reloadfop_mail_host_box_dir_email_attachment();
        
    }

		var i9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1atimeout = null;
		function changefilter_fop_mail_host_box_dir_email_attachment_emailSearchFilter(val, callback) {
			if(i9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1atimeout) clearTimeout(i9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1atimeout);

			i9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1atimeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_dir_email_attachment({action: 'getfilter_fop_mail_host_box_dir_email_attachment_emailItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_dir_email_attachment_email_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_dir_email_attachment_emailListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_dir_email_attachment_email_orig']) ? json_encode($_GET['filter_fop_mail_host_box_dir_email_attachment_email_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1a" type="text">' +
			'<label class="mdl-textfield__label" for="9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1a">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_dir_email_attachment_email', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_dir_email_attachment_email_orig'] = '';
					delete query['filter_fop_mail_host_box_dir_email_attachment_email'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_dir_email_attachment();
					
				} else {
					$('#table_fop_mail_host_box_dir_email_attachment').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_dir_email_attachment_emailSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_dir_email_attachment::getfilter_fop_mail_host_box_dir_email_attachment_emailItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_dir_email_attachment_email_orig'] = '';
				delete query['filter_fop_mail_host_box_dir_email_attachment_email'];
				reload('', items);reloadfop_mail_host_box_dir_email_attachment();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_dir_email_attachment_email', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_dir_email_attachment_emailListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_fop_mail_host_box_dir_email_attachment_emailListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_dir_email_attachment_email', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_dir_email_attachment_email'];
		  }reloadfop_mail_host_box_dir_email_attachment();
        
    }

		var i9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1atimeout = null;
		function changefilter_fop_mail_host_box_dir_email_attachment_emailSearchFilter(val, callback) {
			if(i9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1atimeout) clearTimeout(i9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1atimeout);

			i9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1atimeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_dir_email_attachment({action: 'getfilter_fop_mail_host_box_dir_email_attachment_emailItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_dir_email_attachment_email_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_dir_email_attachment_emailListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_dir_email_attachment_email_orig']) ? json_encode($_GET['filter_fop_mail_host_box_dir_email_attachment_email_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1a" type="text">' +
			'<label class="mdl-textfield__label" for="9a1afae103cc3a5bd50e2a5579644d97f38505f3a04cb07f4024e777dd1efd1a">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_dir_email_attachment_email', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_dir_email_attachment_email_orig'] = '';
					delete query['filter_fop_mail_host_box_dir_email_attachment_email'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_dir_email_attachment();
					
				} else {
					$('#table_fop_mail_host_box_dir_email_attachment').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_dir_email_attachment_emailSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_dir_email_attachment::getfilter_fop_mail_host_box_dir_email_attachment_emailItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_dir_email_attachment_email_orig'] = '';
				delete query['filter_fop_mail_host_box_dir_email_attachment_email'];
				reload('', items);reloadfop_mail_host_box_dir_email_attachment();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_dir_email_attachment_email', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_dir_email_attachment_emailListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumberfop_mail_host_box_dir_email_attachment(col) {
										//var checklist = window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['fop_mail_host_box_dir_email_attachment'] && window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col].ranges.length > 0) {
											$('.fop_mail_host_box_dir_email_attachment__mass-action').css('visibility', 'visible');
											$('.fop_mail_host_box_dir_email_attachment__action').css('visibility', 'hidden');
										} else {
											$('.fop_mail_host_box_dir_email_attachment__mass-action').css('visibility', 'hidden');
											$('.fop_mail_host_box_dir_email_attachment__action').css('visibility', 'visible');
										}
										$('.fop_mail_host_box_dir_email_attachment__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('fop_mail_host_box_dir_email_attachment__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('fop_mail_host_box_dir_email_attachment__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadfop_mail_host_box_dir_email_attachment (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/Fop_mail_host_box_dir_email_attachment/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/Fop_mail_host_box_dir_email_attachment/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#fop_mail_host_box_dir_email_attachment-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#fop_mail_host_box_dir_email_attachment-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#fop_mail_host_box_dir_email_attachment-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberfop_mail_host_box_dir_email_attachment('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#fop_mail_host_box_dir_email_attachment-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadfop_mail_host_box_dir_email_attachment()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkfop_mail_host_box_dir_email_attachment (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['fop_mail_host_box_dir_email_attachment']) window.DataViewChecked['fop_mail_host_box_dir_email_attachment'] = {};
										if (!window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col]) window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadfop_mail_host_box_dir_email_attachment({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col] = new IDList(ids);
													updateNumberfop_mail_host_box_dir_email_attachment(col);
												});
											} else {
												window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col] = new IDList();
												updateNumberfop_mail_host_box_dir_email_attachment(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#fop_mail_host_box_dir_email_attachment__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col].push(id);
												} else {
													window.DataViewChecked['fop_mail_host_box_dir_email_attachment'][col].remove(id);
												}
											}
											updateNumberfop_mail_host_box_dir_email_attachment(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadfop_mail_host_box_dir_email_attachment();
			
		}

	</script>
	<?php
	
    
  }

  public static function renderTabTableAction() { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((false))) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="
		var self = this;
		event.preventDefault();
		$.get(reloadfop_mail_host_box_dir_email_attachment({action: 'open', fop_table: 'fop_mail_host_box_dir_email_attachment', fop_id: '_', fop_from: location.href}, true))
		.then(function () {
			window.open_url(self.href, false);
		});" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir_email_attachment::createURL2(['from' => $_GET['from'] ?? null, 'popup' => $_GET['popup'] ?? null])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('attachment'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_fop_mail_host_box_dir_email_attachment']) ? intval($_GET['page_fop_mail_host_box_dir_email_attachment']) : 0);
								$addlines = (isset($_GET['addlines_fop_mail_host_box_dir_email_attachment']) ? intval($_GET['addlines_fop_mail_host_box_dir_email_attachment']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'email',
												'desc' => _('email'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['email'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'file',
												'desc' => _('file'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['file'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('fop_mail_host_box_dir_email_attachment'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='email'
												data-order='<?php echo intval($columns['email']['order']); ?>'
												data-width='<?php echo intval($columns['email']['width']); ?>'
												data-collapsed='<?php echo intval($columns['email']['collapsed']); ?>'
												style='width: <?php echo intval($columns['email']['width']); ?>px; <?php if ($columns['email']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_dir_email_attachment(); 
		}});
		
		win.append(getfilter_fop_mail_host_box_dir_email_attachment_emailListMultiFilter()); win.find('input').first().focus();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_dir_email_attachment'] == 'email ASC') {
			query['sort_fop_mail_host_box_dir_email_attachment'] = 'email DESC';
		 } else if (query['sort_fop_mail_host_box_dir_email_attachment'] == 'email DESC') {
		 	delete query['sort_fop_mail_host_box_dir_email_attachment'];
		 } else {
			query['sort_fop_mail_host_box_dir_email_attachment'] = 'email ASC';
		 }
		 reloadfop_mail_host_box_dir_email_attachment();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('email')); ?>'><?php echo(_('email')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_dir_email_attachment']) && $_GET['sort_fop_mail_host_box_dir_email_attachment'] == 'email ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_dir_email_attachment']) && $_GET['sort_fop_mail_host_box_dir_email_attachment'] == 'email DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_dir_email_attachment_email']) || isset($_GET['range_max_fop_mail_host_box_dir_email_attachment_email']) || isset($_GET['deps_fop_mail_host_box_dir_email_attachment_email']) || isset($_GET['fullsearch_fop_mail_host_box_dir_email_attachment_email']) || isset($_GET['dynamic_fop_mail_host_box_dir_email_attachment_email']) || isset($_GET['search_fop_mail_host_box_dir_email_attachment_email']) || isset($_GET['searchnot_fop_mail_host_box_dir_email_attachment_email']) || isset($_GET['filter_fop_mail_host_box_dir_email_attachment_email'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['email']['header'] = ob_get_contents(); ob_end_clean();
											$columns['email']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['email']['width']); ?>px; <?php if ($columns['email']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='email'><?php
	
	call_user_func(function () use ($item) {
	$id = $item['email'];
	$val = $item['email::description'];
	$canView = $item['email::canView'];
	if ($val !== null) {
		if ($canView) echo "<a tabindex=\"-1\" class=\"mdl-button mdl-button-small tbl-link\" data-tbl=\"fop_mail_host_box_dir_email\" data-id=\"".htmlentities($id)."\" onclick=\"event.stopPropagation(); event.preventDefault(); open_url(this.href, false);\" href=\"" . \TablesRouter\Fop_mail_host_box_dir_email::viewURL($id, ['from' => \FOP\Util::getBackURL()]) . "\">(…)</a>";echo htmlentities($val);
	} else {
		echo htmlentities(_('') ?: '-');
	}
	});
	
?>
</div><?php
											};
											$columns['email']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='email'
													data-order='<?php echo intval($columns['email']['order']); ?>'
													data-width='<?php echo intval($columns['email']['width']); ?>'
													data-collapsed='<?php echo intval($columns['email']['collapsed']); ?>'
													style='width: <?php echo intval($columns['email']['width']); ?>px; <?php if ($columns['email']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='file'
												data-order='<?php echo intval($columns['file']['order']); ?>'
												data-width='<?php echo intval($columns['file']['width']); ?>'
												data-collapsed='<?php echo intval($columns['file']['collapsed']); ?>'
												style='width: <?php echo intval($columns['file']['width']); ?>px; <?php if ($columns['file']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_dir_email_attachment(); 
		}});
		var el, text;
		win.append(el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		text = el.find('input');
		text.val(query['fullsearch_fop_mail_host_box_dir_email_attachment_file']);
		text.on('change keyup paste', function () { query['fullsearch_fop_mail_host_box_dir_email_attachment_file'] = text.val(); delete query['page_fop_mail_host_box_dir_email_attachment']; changed = true; });
		text.focus();
		text.select();
		return false;
	">
													<span class='title-title' title='<?php echo(_('file')); ?>'><?php echo(_('file')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_dir_email_attachment']) && $_GET['sort_fop_mail_host_box_dir_email_attachment'] == 'file ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_dir_email_attachment']) && $_GET['sort_fop_mail_host_box_dir_email_attachment'] == 'file DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_dir_email_attachment_file']) || isset($_GET['range_max_fop_mail_host_box_dir_email_attachment_file']) || isset($_GET['deps_fop_mail_host_box_dir_email_attachment_file']) || isset($_GET['fullsearch_fop_mail_host_box_dir_email_attachment_file']) || isset($_GET['dynamic_fop_mail_host_box_dir_email_attachment_file']) || isset($_GET['search_fop_mail_host_box_dir_email_attachment_file']) || isset($_GET['searchnot_fop_mail_host_box_dir_email_attachment_file']) || isset($_GET['filter_fop_mail_host_box_dir_email_attachment_file'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['file']['header'] = ob_get_contents(); ob_end_clean();
											$columns['file']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['file']['width']); ?>px; <?php if ($columns['file']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='file'><?php if ($item['file']) { ?><a target='_blank' onclick='event.stopPropagation()' href='fop-files/<?php echo urlencode(htmlentities($item['file'])); ?>/x'><?php call_user_func(function($v) { $result = \FOP\Database::query('SELECT filename FROM fop_files WHERE '.qi('ID').' = '.intval($v))->fetch(\PDO::FETCH_ASSOC); echo htmlentities($result['filename']); }, $item['file']); ?></a><?php } else { echo '-'; } ?></div><?php
											};
											$columns['file']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='file'
													data-order='<?php echo intval($columns['file']['order']); ?>'
													data-width='<?php echo intval($columns['file']['width']); ?>'
													data-collapsed='<?php echo intval($columns['file']['collapsed']); ?>'
													style='width: <?php echo intval($columns['file']['width']); ?>px; <?php if ($columns['file']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#fop_mail_host_box_dir_email_attachment-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#fop_mail_host_box_dir_email_attachment-table .fop-table-header .fop-table-column .title,
										#fop_mail_host_box_dir_email_attachment-table .fop-column-handle,
										#fop_mail_host_box_dir_email_attachment-table .fop-table-row,
										#fop_mail_host_box_dir_email_attachment-table .fop-table-row .fop-table-column,
										#fop_mail_host_box_dir_email_attachment-table .fop-table-column-multicontrol,
										#fop_mail_host_box_dir_email_attachment-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="fop_mail_host_box_dir_email_attachment">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="fop_mail_host_box_dir_email_attachment__all-checkbox">
														<input class="mdl-checkbox__input" id="fop_mail_host_box_dir_email_attachment__all-checkbox" type="checkbox" onchange="checkfop_mail_host_box_dir_email_attachment('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_mail_host_box_dir_email_attachment__mass-action" style='visibility: hidden;' onclick="$.get('DataView/Fop_mail_host_box_dir_email_attachment/permissions?id=' + checkfop_mail_host_box_dir_email_attachment(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_fop_mail_host_box_dir_email_attachment_') == 0 || key.indexOf('range_max_fop_mail_host_box_dir_email_attachment_') == 0 || key.indexOf('deps_fop_mail_host_box_dir_email_attachment_') == 0 || key.indexOf('fullsearch_fop_mail_host_box_dir_email_attachment_') == 0 || key.indexOf('dynamic_fop_mail_host_box_dir_email_attachment_') == 0 || key.indexOf('search_fop_mail_host_box_dir_email_attachment_') == 0 || key.indexOf('searchnot_fop_mail_host_box_dir_email_attachment_') == 0 || key.indexOf('filter_fop_mail_host_box_dir_email_attachment_') == 0) delete query[key]; reloadfop_mail_host_box_dir_email_attachment(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_fop_mail_host_box_dir_email_attachment_ID'] = checkfop_mail_host_box_dir_email_attachment(null, 'ID'); delete query['page_fop_mail_host_box_dir_email_attachment']; reloadfop_mail_host_box_dir_email_attachment(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkfop_mail_host_box_dir_email_attachment(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkfop_mail_host_box_dir_email_attachment(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && ((false))) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/Fop_mail_host_box_dir_email_attachment/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkfop_mail_host_box_dir_email_attachment(null, 'ID'))).then(function () { reloadfop_mail_host_box_dir_email_attachment(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('fop_mail_host_box_dir_email_attachment', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'fop_mail_host_box_dir_email_attachment', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_fop_mail_host_box_dir_email_attachment" <?php \EasyEditor\Navigation::printScroll('dv.Fop_mail_host_box_dir_email_attachment', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_fop_mail_host_box_dir_email_attachment\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_fop_mail_host_box_dir_email_attachment\'] = wantedPage;
														reloadfop_mail_host_box_dir_email_attachment(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-fop_mail_host_box_dir_email_attachment-id="<?php echo htmlentities($item['ID']); ?>">

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox fop_mail_host_box_dir_email_attachment__checkbox fop_mail_host_box_dir_email_attachment__checkbox fop_mail_host_box_dir_email_attachment__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="fop_mail_host_box_dir_email_attachment__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="fop_mail_host_box_dir_email_attachment__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkfop_mail_host_box_dir_email_attachment(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_mail_host_box_dir_email_attachment__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-fop_mail_host_box_dir_email_attachment-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir_email_attachment::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/Fop_mail_host_box_dir_email_attachment/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadfop_mail_host_box_dir_email_attachment(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_mail_host_box_dir_email_attachment" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir_email_attachment::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadfop_mail_host_box_dir_email_attachment();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function getidsAction($col) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE ((FALSE)) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('fop_mail_host_box_dir_email_attachment').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getSQL($params) { 
    
    
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* email */ '.qi('email').' AS '.qi('email').',
									/* email::canView */ '.qi('ref:email').'.'.qi('email:canView').' AS '.qi('email::canView').',
									/* email::description */ '.qi('ref:email').'.'.qi('email:description').' AS '.qi('email::description').',
									/* file */ '.qi('file').' AS '.qi('file').',
									/* operation::create */ ' . ((false) ? 1 : 0) . ' AS '.qi('operation::create').',
									/* operation::delete */ (FALSE) AS '.qi('operation::delete').',
									/* operation::edit */ (FALSE) AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::view').',
									1
								FROM '.qi('fop_mail_host_box_dir_email_attachment').' '.qi('fop_mail_host_box_dir_email_attachment').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('email:ID').', CONCAT((SELECT (CONCAT('.qi('CBD4eCc3').'.'.qi('display').', \' <\', '.qi('CBD4eCc3').'.'.qi('address').', \'>\')) FROM '.qi('fop_mail_host_box_dir_email_recipient').' '.qi('CBD4eCc3').' WHERE '.qi('CBD4eCc3').'.'.qi('email').' = '.qi('fop_mail_host_box_dir_email').'.'.qi('ID').' LIMIT 1), \' - \', '.qi('fop_mail_host_box_dir_email').'.'.qi('subject').', \' (\', '.(\FOP\Database::getDriver() == 'mysql' ? 'DATE_FORMAT(FROM_UNIXTIME' : 'to_char(to_timestamp') . '('.qi('fop_mail_host_box_dir_email').'.'.qi('timestamp').')' . ', '.\FOP\Database::sessionVarSQL('datetimeformat').'), \')\') AS '.qi('email:description').', (('.\FOP\Database::quote(\FOP\User::getIsLoggedIn()).') AND (COALESCE((SELECT (COALESCE((SELECT (CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('1IDxgk3w').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) FROM '.qi('fop_mail_host_box').' '.qi('1IDxgk3w').' WHERE '.qi('1IDxgk3w').'.'.qi('ID').' = '.qi('p0EDqmbn').'.'.qi('mailbox').' LIMIT 1), FALSE)) FROM '.qi('fop_mail_host_box_dir').' '.qi('p0EDqmbn').' WHERE '.qi('p0EDqmbn').'.'.qi('ID').' = '.qi('fop_mail_host_box_dir_email').'.'.qi('directory').' LIMIT 1), FALSE))) AS '.qi('email:canView').' FROM '.qi('fop_mail_host_box_dir_email').') '.qi('ref:email').' ON '.qi('ref:email').'.'.qi('email:ID').' = '.qi('email').'
								WHERE (('.(\FOP\User::getIsGuest() ? 'false' : 'true').'))) AS t
								LEFT JOIN '.qi('fop_mail_host_box_dir_email').' AS '.qi('sorter-email').' ON t.'.qi('email').' = '.qi('sorter-email').'.'.qi('ID').'
								WHERE ' . (isset($params['fullsearch_fop_mail_host_box_dir_email_attachment_file']) && $params['fullsearch_fop_mail_host_box_dir_email_attachment_file'] ? 't.'.qi('file').' IN (SELECT '.qi('ID').' FROM fop_files WHERE filename LIKE '.\FOP\Database::quote('%' . $params['fullsearch_fop_mail_host_box_dir_email_attachment_file'] . '%').') AND ' : '') . 
								(isset($params['filter_fop_mail_host_box_dir_email_attachment_email']) ? ($params['filter_fop_mail_host_box_dir_email_attachment_email'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_attachment_email']))->toSQL('t.'.qi('email').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_email_attachment_file']) ? ($params['filter_fop_mail_host_box_dir_email_attachment_file'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_attachment_file']))->toSQL('t.'.qi('file').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_email_attachment_ID']) ? ($params['filter_fop_mail_host_box_dir_email_attachment_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_attachment_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getfilter_fop_mail_host_box_dir_email_attachment_emailItemsByStringAction($fstr) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_fop_mail_host_box_dir_email_attachment_email']);
		return \Types\Fop_mail_host_box_dir_email::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('email').''.self::getSQL($params).')');
	

    
  }

  public static function getData($sqladdon, $params, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params);

								$order = (\FOP\Util::array_value(array(
									'email ASC' => 'ORDER BY '.qi('sorter-email').'.'.qi('timestamp').' DESC, '.qi('sorter-email').'.'.qi('timestamp').' DESC, '.qi('sorter-email').'.'.qi('timestamp').' DESC, '.qi('sorter-email').'.'.qi('timestamp').' DESC, '.qi('sorter-email').'.'.qi('timestamp').' DESC',
									'email DESC' => 'ORDER BY '.qi('sorter-email').'.'.qi('timestamp').' ASC, '.qi('sorter-email').'.'.qi('timestamp').' ASC, '.qi('sorter-email').'.'.qi('timestamp').' ASC, '.qi('sorter-email').'.'.qi('timestamp').' ASC, '.qi('sorter-email').'.'.qi('timestamp').' ASC',
									'' => ''), isset($params['sort_fop_mail_host_box_dir_email_attachment']) ? $params['sort_fop_mail_host_box_dir_email_attachment'] : '') ?: '');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['email'] = \FOP\Sanitizers::null_converter($item['email']);
											$item['file'] = intval($item['file']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['email'] = \FOP\Sanitizers::null_converter($item['email']);
										$item['file'] = intval($item['file']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		if (isset($params['fullsearch_fop_mail_host_box_dir_email_attachment_file'])) {
		array_push($filters, _('file') . ' ' . _('filter_contains') . ' ' . $params['fullsearch_fop_mail_host_box_dir_email_attachment_file']);
	}if (isset($params['filter_fop_mail_host_box_dir_email_attachment_file'])) {
		if ($params['filter_fop_mail_host_box_dir_email_attachment_file'] == '_null') {
			array_push($filters, _('file') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_attachment_file']))->all() AS $val) {
				$value = \FOP\Database::query('SELECT filename FROM fop_files WHERE '.qi('ID').' = ' . intval($val))->fetchColumn();
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('file') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_dir_email_attachment_email'])) {
		if ($params['filter_fop_mail_host_box_dir_email_attachment_email'] == '_null') {
			array_push($filters, _('email') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_attachment_email']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT CONCAT((SELECT (CONCAT('.qi('CBD4eCc3').'.'.qi('display').', \' <\', '.qi('CBD4eCc3').'.'.qi('address').', \'>\')) FROM '.qi('fop_mail_host_box_dir_email_recipient').' '.qi('CBD4eCc3').' WHERE '.qi('CBD4eCc3').'.'.qi('email').' = '.qi('fop_mail_host_box_dir_email').'.'.qi('ID').' LIMIT 1), \' - \', '.qi('fop_mail_host_box_dir_email').'.'.qi('subject').', \' (\', '.(\FOP\Database::getDriver() == 'mysql' ? 'DATE_FORMAT(FROM_UNIXTIME' : 'to_char(to_timestamp') . '('.qi('fop_mail_host_box_dir_email').'.'.qi('timestamp').')' . ', '.\FOP\Database::sessionVarSQL('datetimeformat').'), \')\') AS description FROM '.qi('fop_mail_host_box_dir_email').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('email') . ': ' . implode(', ', $values));
		}
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_fop_mail_host_box_dir_email_attachment_\')) delete query[q];} reloadfop_mail_host_box_dir_email_attachment(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'fop_mail_host_box_dir_email_attachment') {
	\FOP\Session::setPayload('dv-fop_mail_host_box_dir_email_attachment', [
		'id' => 'fop_mail_host_box_dir_email_attachment',
		'tbl' => 'fop_mail_host_box_dir_email_attachment',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\Fop_mail_host_box_dir_email_attachment::stepURL('fop_mail_host_box_dir_email_attachment', 'XXX', -1),
		'next' => \DataViewRouter\Fop_mail_host_box_dir_email_attachment::stepURL('fop_mail_host_box_dir_email_attachment', 'XXX',  1),
		'from' => $fop_from
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\Fop_mail_host_box_dir_email_attachment::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



